# Class AnnotationDefault

java.lang.Object
org.apache.bcel.classfile.Attribute
org.apache.bcel.classfile.AnnotationDefault

All Implemented Interfaces:
  `Cloneable, Node`

public class AnnotationDefault extends Attribute
Represents the default value of a annotation for a method info.

Since:
  6.0

- ## Field Summary

  ### Fields inherited from class Attribute

  `constant_pool, EMPTY_ARRAY, length, name_index, tag`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `AnnotationDefault(int nameIndex, int length, ElementValue defaultValue, ConstantPool constantPool)`
  Constructs an AnnotationDefault attribute.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `accept(Visitor v)`
  Called by objects that are traversing the nodes of the tree implicitly defined by the contents of a Java class.
  `Attribute`
  `copy(ConstantPool constantPool)`
  Creates a deep copy of this attribute.
  `final void`
  `dump(DataOutputStream dos)`
  Dumps attribute to file stream in binary format.
  `final ElementValue`
  `getDefaultValue()`
  Gets the default value.
  `final void`
  `setDefaultValue(ElementValue defaultValue)`
  Sets the default value of this methodinfo's annotation.

  ### Methods inherited from class Attribute

  `addAttributeReader, addAttributeReader, clone, getConstantPool, getLength, getName, getNameIndex, getTag, println, readAttribute, readAttribute, removeAttributeReader, setConstantPool, setLength, setNameIndex, toString`

  ### Methods inherited from class Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### AnnotationDefault

    public AnnotationDefault(int nameIndex, int length, ElementValue defaultValue, ConstantPool constantPool)
    Constructs an AnnotationDefault attribute.
    Parameters:
      `nameIndex` - Index pointing to the name Code.
      `length` - Content length in bytes.
      `defaultValue` - the annotation's default value.
      `constantPool` - Array of constants.

- ## Method Details

  - ### accept

    public void accept(Visitor v)
    Called by objects that are traversing the nodes of the tree implicitly defined by the contents of a Java class. I.e., the hierarchy of methods, fields, attributes, etc. spawns a tree of objects.
    Specified by:
      `accept` in interface `Node`
    Specified by:
      `accept` in class `Attribute`
    Parameters:
      `v` - Visitor object.

  - ### copy

    public Attribute copy(ConstantPool constantPool)
    Description copied from class: `Attribute`
    Creates a deep copy of this attribute.
    Specified by:
      `copy` in class `Attribute`
    Parameters:
      `constantPool` - constant pool to save.
    Returns:
      deep copy of this attribute.

  - ### dump

    public final void dump(DataOutputStream dos) throws IOException
    Description copied from class: `Attribute`
    Dumps attribute to file stream in binary format.
    Overrides:
      `dump` in class `Attribute`
    Parameters:
      `dos` - Output file stream.
    Throws:
      `IOException` - if an I/O error occurs.

  - ### getDefaultValue

    public final ElementValue getDefaultValue()
    Gets the default value.
    Returns:
      the default value.

  - ### setDefaultValue

    public final void setDefaultValue(ElementValue defaultValue)
    Sets the default value of this methodinfo's annotation.
    Parameters:
      `defaultValue` - the default value of this methodinfo's annotation.